unit mandlpal;

INTERFACE

type
  rgbPtr = ^rgb;
  rgb = record
          rot, gruen, blau: byte;
          naechste: rgbPtr;
        end;
  xPalette=^sPalette;
  sPalette=object
             farbe: rgbPtr;
             farbAnzahl: byte;
             constructor init(farbAnz: byte; datei: string);
             procedure speichern(name:string); VIRTUAL;
             function laden(name:string): boolean; VIRTUAL;
             procedure setRGB(farbNr,r,g,b:byte); VIRTUAL;
             procedure getRGB(farbNR: byte; var r,g,b: byte); VIRTUAL;
             procedure neueLaden(var name:string);
             function echtFarb(farbNr:byte):byte; VIRTUAL;
             destructor ende; VIRTUAL;
           end;


IMPLEMENTATION
uses
  dos,wandler,mndluni2;

function sPalette.echtFarb(farbNr:byte):byte;
begin
  if farbAnzahl <> 15 then echtFarb:=farbNr else
    case farbNr of
      6: echtFarb:=20;
      8..15: echtFarb:=(farbNr + 48);
     else echtFarb:=farbNr;
    end;
end;

constructor sPalette.init(farbAnz: byte; datei: string);
var
  i: byte;
  alt, neu: rgbPtr;
begin
  farbAnzahl:= farbAnz;
  new(farbe);
  farbe^.rot:=0;
  farbe^.gruen:=0;
  farbe^.blau:=0;
  alt:=farbe;
  for i:=0 to (farbAnz - 1) do
  begin
    new(neu);
    alt^.naechste:= neu;
    alt:= neu;
    neu^.rot:=0;
    neu^.gruen:=0;
    neu^.blau:=0;
  end;
  neu^.naechste:=nil;
  laden(datei);
end;

procedure sPalette.neueLaden(var name: string);
var
  DirInfo: SearchRec;
  anzahl,j,nichtNehmen,nehmen: byte;
  geladen: boolean;
begin
  anzahl:=0;
  FindFirst('*.vmp', Archive, DirInfo);
  while (DosError = 0) do
  begin
    inc(anzahl);
    if dirInfo.name=name then nichtNehmen:=anzahl;
    FindNext(DirInfo);
  end;
  repeat
    repeat
      nehmen:=(random(anzahl) + 1);
    until nehmen<>nichtNehmen;
    FindFirst('*.vmp', Archive, DirInfo);
    for j:= 1 to (nehmen - 1) do
      if dosError = 0 then findNext(dirInfo);
    name:=dirInfo.name;
    geladen:= laden(name);
  until geladen;
end;

procedure sPalette.setRGB(farbNr,r,g,b:byte);
var
  lauf:rgbPtr;
  i: byte;
begin
  port[$3c8]:=echtFarb(farbNr);
  port[$3c9]:=r;
  port[$3c9]:=g;
  port[$3c9]:=b;
  lauf:=farbe;
  i:=0;
  repeat
    if i=farbNr then
    begin
      lauf^.rot:=r;
      lauf^.gruen:=g;
      lauf^.blau:=b;
    end;
    inc(i);
    lauf:=lauf^.naechste;
  until ( (i > farbNr) or (lauf=nil));
end;

procedure sPalette.getRGB(farbNR: byte; var r,g,b: byte);
var
  lauf:rgbPtr;
  i: byte;
begin
  lauf:=farbe;
  i:=0;
  repeat
    if i=farbNr then
    begin
      r:=lauf^.rot;
      g:=lauf^.gruen;
      b:=lauf^.blau;
    end;
    inc(i);
    lauf:=lauf^.naechste;
  until ( (i > farbNr) or (lauf=nil));
end;

procedure sPalette.speichern(name:string);
var
  datei: text;
  r,g,b,i:byte;
begin
  assign(datei,name);
  rewrite(datei);
  writeln(datei,'Farbpalette, erzeugt von Vlado''s MandelZoom am '+datum);
  writeln(datei,'Farben: '+int2str(farbAnzahl+1));
  writeln(datei,'    rot, grn, blau');
  for i:=0 to farbAnzahl do
  begin
    getRGB(i,r,g,b);
    writeln(datei,i:3,': ',r:3,',',g:3,',',b:3);
  end;
  close(datei);
end;

function sPalette.laden(name:string): boolean;
var
  datei: text;
  r,g,b,i:byte;
  zeile: string;
  hilfPtr: RGBptr;
  geladen: boolean;
begin
  geladen:=false;
  assign(datei,name);
  {$i-}
  reset(datei);
  {$i+}
  if ioresult=0 then
  begin
    readln(datei,zeile);
    delete(zeile,33,length(zeile));
    if zeile='Farbpalette, erzeugt von Vlado''s' then
    begin
      readln(datei,zeile);
      delete(zeile,1,8);
      if str2int(zeile) = (farbAnzahl + 1) then
      begin
        geladen:=true;
        readln(datei,zeile);
        hilfPtr:=farbe;
        i:=0;
        repeat
          readln(datei,zeile);
          r:=str2int(zeile[6]+zeile[7]+zeile[8]);
          g:=str2int(zeile[10]+zeile[11]+zeile[12]);
          b:=str2int(zeile[14]+zeile[15]+zeile[16]);
          setRGB(i,r,g,b);
          hilfPtr^.rot:=r;
          hilfPtr^.gruen:=g;
          hilfPtr^.blau:=b;
          hilfPtr:=hilfPtr^.naechste;
          inc(i);
        until ( (eof(datei)) or (hilfPtr=nil) );
      end;
    end;
    close(datei);
  end;
  laden:=geladen;
end;

destructor sPalette.ende;
var
  work,lauf: rgbPtr;
begin
  lauf:=farbe;
  while (lauf <> nil) do
  begin
    work:=lauf;
    lauf:=work^.naechste;
    dispose(work);
  end;
end;

end.